# How to contribute

It is a paramount to the development of `litesome` that the community is empowered to make changes and get them into the library. Here are some guidelines for making a cake walk through this process.

## Reporting issues

To report a bug, request a feature, or even ask a question, make use of the GitHub Issues
section. When submitting an issue please take the following steps:

1. **Seach for existing issues.** Your question or bug may have already been answered or fixed, be sure to search the issues first before putting in a duplicate issue.

2. **Create an isolated and reproducible test case.** If you are reporting a bug, make sure you also have a minimal, runnable, code example that reproduces the problem you have.

3. **Share as much information as possible.** Include browser version affected, your OS, version of
   the library, steps to reproduce, etc. "X isn't working!!!1!" will probably just be closed.

## Contributing Changes

### Setting Up

To setup for making changes you will need to take a few steps, we've outlined them below:

1. Ensure you have [node][node] and npm installed.

2. Fork the [litesome][litesome] repository, if you are unsure how to do this GitHub has a guides for the [command line][fork-repo] and for the [GitHub Client][fork-client].

3. Next, run `npm install` from within the clone of your fork. That will install all dependencies necessary to build litesome.

4. Lastly, compile codes with just running `npm gulp:minify` or `yarn gulp:minigy` from within the project.

### Making a Change

Once you have the repository on your machine and have installed dependencies you are almost ready to make your change(s). The only other thing to do before you start is to checkout to the correct branch. Which branch you should make your change to (and send a PR to) depends on the type of change you are making.

Always make sure to create PR to the`develop` as it is the branch for feature compilation before pushing to master.

Your change should be made directly to the branch in your fork, or to a branch in your fork made off of one of the above branches.

### Branch Naming

Branches created should be named using the following format:

```
{type}-{2-3 word summary separated with hyphen}
```

Type:

- feature
- bug
- chore
- refactor

Example:

```
refactor-data
```

### PR Description Template

The description of the PR should contain the following headings and corresponding content in Markdown format.

```
#### What does this PR do?
#### Description of Task to be completed?
#### How should this be manually tested?
#### Any background context you want to provide?
#### Screenshots
```

### Submitting Your Change

After you have made and tested your change, commit and push it to your fork. Then, open a Pull Request from your fork to the main `litesome` repository on the branch you used in the `Making a Change` section of this document.
